unit uplot3d;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, StdCtrls, Buttons, ExtCtrls,
  Menus,
  SDL_sdlbase, SDL_Colsel, SDL_NumLab, SDL_plot3d;

type
  TForm1 = class(TForm)
    Plot3D1: TPlot3D;
    Panel2: TPanel;
    ScrBarAngleZ: TScrollBar;
    ScrBarAngleX: TScrollBar;
    CSelHigh: TColSel;
    CSelLow: TColSel;
    CSelGrid: TColSel;
    NLabZ: TNumLab;
    ScrBarMagnif: TScrollBar;
    BButExit: TBitBtn;
    CBoxMesh: TCheckBox;
    NLabX: TNumLab;
    Label1: TLabel;
    popMenMouse: TPopupMenu;
    Rotate1: TMenuItem;
    Pan1: TMenuItem;
    Zoom1: TMenuItem;
    RotateandZoom1: TMenuItem;
    RotXOnly1: TMenuItem;
    RotZOnly1: TMenuItem;
    NLabMag: TNumLab;
    Label2: TLabel;
    CselMid: TColSel;
    ScrBarColorHigh: TScrollBar;
    CBox3colmod: TCheckBox;
    Label3: TLabel;
    LblColMid: TLabel;
    Label5: TLabel;
    Label4: TLabel;
    ScrBarSclZ: TScrollBar;
    ScrBarSclY: TScrollBar;
    ScrBarSclX: TScrollBar;
    SBReset: TSpeedButton;
    NLabCellX: TNumLab;
    NLabCellY: TNumLab;
    CBoxGridCursor: TCheckBox;
    CBoxXCoords: TCheckBox;
    CBoxYCoords: TCheckBox;
    CBoxZcoords: TCheckBox;
    ColSelX: TColSel;
    ColSelY: TColSel;
    ColSelZ: TColSel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    RGFrameMode: TRadioGroup;
    NLX: TNumLab;
    NLY: TNumLab;
    NLZ: TNumLab;
    procedure BButExitClick(Sender: TObject);
    procedure ScrBarAngleXChange(Sender: TObject);
    procedure ScrBarAngleZChange(Sender: TObject);
    procedure ScrBarMagnifChange(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure CSelHighChange(Sender: TObject);
    procedure CSelLowChange(Sender: TObject);
    procedure CSelGridChange(Sender: TObject);
    procedure CBoxMeshClick(Sender: TObject);
    procedure Rotate1Click(Sender: TObject);
    procedure Pan1Click(Sender: TObject);
    procedure Zoom1Click(Sender: TObject);
    procedure RotateandZoom1Click(Sender: TObject);
    procedure RotXOnly1Click(Sender: TObject);
    procedure RotZOnly1Click(Sender: TObject);
    procedure Plot3D1MouseAction(Sender: TObject; var CenterX,
      CenterY: Integer; var RotXAngle, RotZAngle, Magnification: Double;
      Shift: TShiftState);
    procedure CselMidChange(Sender: TObject);
    procedure ScrBarColorHighChange(Sender: TObject);
    procedure CBox3colmodClick(Sender: TObject);
    procedure ScrBarSclZChange(Sender: TObject);
    procedure ScrBarSclXChange(Sender: TObject);
    procedure ScrBarSclYChange(Sender: TObject);
    procedure SBResetClick(Sender: TObject);
    procedure Plot3D1BeforeRenderPolygon(Sender: TObject;
      var Canvas: TCanvas; var Handled: Boolean; CellX, CellY: Integer;
      quad: TQuad; var color: TColor);
    procedure Plot3D1DataRendered(Sender: TObject; var Canvas: TCanvas);
    procedure Plot3D1MouseMoveOverPlot(Sender: TObject; OverPlot: Boolean;
      Shift: TShiftState; MouseCellX, MouseCellY: Integer);
    procedure CBoxZcoordsClick(Sender: TObject);
    procedure ColSelXChange(Sender: TObject);
    procedure ColSelYChange(Sender: TObject);
    procedure ColSelZChange(Sender: TObject);
    procedure RGFrameModeClick(Sender: TObject);
  private
    MCellX, MCellY : integer;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

const
  XRes = 40;
  YRes = 40;

{$R *.DFM}

(**************************************************************************)
procedure TForm1.BButExitClick(Sender: TObject);
(**************************************************************************)

begin
close;
end;

(******************************************************************************)
procedure TForm1.ScrBarAngleXChange(Sender: TObject);
(******************************************************************************)

begin
Plot3D1.ViewAngleX := ScrBarAngleX.Position;
NLabX.Value := ScrBarAngleX.Position;
end;

(******************************************************************************)
procedure TForm1.ScrBarAngleZChange(Sender: TObject);
(******************************************************************************)

begin
Plot3D1.ViewAngleZ := ScrBarAngleZ.Position;
NLabZ.Value := ScrBarAngleZ.Position;
end;

(******************************************************************************)
procedure TForm1.ScrBarMagnifChange(Sender: TObject);
(******************************************************************************)

begin
Plot3d1.Magnification := ScrBarMagnif.position/100;
NLabMag.Value := ScrBarMagnif.position/100;
end;

(******************************************************************************)
procedure TForm1.FormShow(Sender: TObject);
(******************************************************************************)

var
  i,j : integer;

begin
Plot3D1.GridMat.Resize (XRes,YRes);
for i:=1 to XRes do
  for j:=1 to YRes do
    Plot3D1.GridMat.Elem[i,j] := sin(i*0.5)*cos(0.15*j)+0.01*(i-(XRes div 2))*(j-(YRes div 2)) +
                                 13*exp(-0.04*(sqr(i-(XRes div 2))+sqr(j-(YRes div 2))))+
                                 10*exp(-0.02*(sqr(i-(XRes div 3))+sqr(j-3*(YRes div 5))))-1;
end;


(******************************************************************************)
procedure TForm1.CSelHighChange(Sender: TObject);
(******************************************************************************)

begin
Plot3D1.ColorHigh := CSelHigh.SelColor;
end;

(******************************************************************************)
procedure TForm1.CSelLowChange(Sender: TObject);
(******************************************************************************)

begin
Plot3D1.ColorLow := CSelLow.SelColor;
end;


(******************************************************************************)
procedure TForm1.CselMidChange(Sender: TObject);
(******************************************************************************)

begin
Plot3D1.ColorMid := CSelMid.SelColor;
end;


(******************************************************************************)
procedure TForm1.CSelGridChange(Sender: TObject);
(******************************************************************************)

begin
Plot3D1.ColorMesh := CSelGrid.SelColor;
end;

(******************************************************************************)
procedure TForm1.CBoxMeshClick(Sender: TObject);
(******************************************************************************)

begin
Plot3D1.MeshVisible := CBoxMesh.Checked;
end;


(******************************************************************************)
procedure TForm1.Rotate1Click(Sender: TObject);
(******************************************************************************)

begin
Plot3D1.MouseAction := maRotate;
end;

(******************************************************************************)
procedure TForm1.Pan1Click(Sender: TObject);
(******************************************************************************)

begin
Plot3D1.MouseAction := maPan;
end;

(******************************************************************************)
procedure TForm1.Zoom1Click(Sender: TObject);
(******************************************************************************)

begin
Plot3D1.MouseAction := maZoom;
end;

(******************************************************************************)
procedure TForm1.RotateandZoom1Click(Sender: TObject);
(******************************************************************************)

begin
Plot3D1.MouseAction := maRotAndZoom;
end;

(******************************************************************************)
procedure TForm1.RotXOnly1Click(Sender: TObject);
(******************************************************************************)

begin
Plot3D1.MouseAction := maRotXOnly;
end;

(******************************************************************************)
procedure TForm1.RotZOnly1Click(Sender: TObject);
(******************************************************************************)

begin
Plot3D1.MouseAction := maRotZOnly;
end;


(******************************************************************************)
procedure TForm1.Plot3D1MouseAction(Sender: TObject; var CenterX,
  CenterY: Integer; var RotXAngle, RotZAngle, Magnification: Double;
  Shift: TShiftState);
(******************************************************************************)

begin
NLabX.Value := RotXAngle;
NLabZ.Value := RotZAngle;
NLabMag.Value := Magnification;
end;


(******************************************************************************)
procedure TForm1.ScrBarColorHighChange(Sender: TObject);
(******************************************************************************)

begin
Plot3D1.ColorScaleHigh := ScrBarColorHigh.Position/10;
Plot3D1.ColorScaleLow := ScrBarColorHigh.Position/10-15;
end;

(******************************************************************************)
procedure TForm1.CBox3colmodClick(Sender: TObject);
(******************************************************************************)

begin
if CBox3ColMod.Checked
  then begin
       Plot3D1.ColorCodingMode := ccmThreeColors;
       LblColMid.Enabled := true;
       CSelMid.Color := clWhite;
       CSelMid.Enabled := true;
       end
  else begin
       Plot3D1.ColorCodingMode := ccmTwoColors;
       LblColMid.Enabled := false;
       CSelMid.Color := clBtnFace;
       CSelMid.Enabled := false;
       end;
end;


(******************************************************************************)
procedure TForm1.ScrBarSclZChange(Sender: TObject);
(******************************************************************************)

begin
Plot3D1.ScaleFactZ := ScrBarSclZ.Position/100;
end;

(******************************************************************************)
procedure TForm1.ScrBarSclXChange(Sender: TObject);
(******************************************************************************)

begin
Plot3D1.ScaleFactX := ScrBarSclX.Position/100;
end;

(******************************************************************************)
procedure TForm1.ScrBarSclYChange(Sender: TObject);
(******************************************************************************)

begin
Plot3D1.ScaleFactY := ScrBarSclY.Position/100;
end;

(******************************************************************************)
procedure TForm1.SBResetClick(Sender: TObject);
(******************************************************************************)

begin
Plot3D1.Reset;
end;



(******************************************************************************)
procedure TForm1.Plot3D1BeforeRenderPolygon(Sender: TObject;
  var Canvas: TCanvas; var Handled: Boolean; CellX, CellY: Integer;
  quad: TQuad; var color: TColor);
(******************************************************************************)

begin
if CBoxGridCursor.Checked then
  if (CellX = MCellX) or (CellY = MCellY) then
    color := clBlue;
end;

(******************************************************************************)
procedure TForm1.Plot3D1DataRendered(Sender: TObject; var Canvas: TCanvas);
(******************************************************************************)

begin
Canvas.Brush.Style := bsClear;
Canvas.Font.Color := clWhite;
Canvas.TextOut(50,50,'This is a text drawn in the OnDataRendered event');
end;

(******************************************************************************)
procedure TForm1.Plot3D1MouseMoveOverPlot(Sender: TObject;
  OverPlot: Boolean; Shift: TShiftState; MouseCellX, MouseCellY: Integer);
(******************************************************************************)

begin
MCellX := MouseCellX;
MCellY := MouseCellY;
if OverPlot
  then begin
       NLabCellX.Value := MouseCellX;
       NLabCellY.Value := MouseCellY;
       NLabCellX.Empty := false;
       NLabCellY.Empty := false;
       end
  else begin
       NLabCellX.Empty := true;
       NLabCellY.Empty := true;
       end;
Plot3d1.Repaint;
end;

(******************************************************************************)
procedure TForm1.CBoxZcoordsClick(Sender: TObject);
(******************************************************************************)

begin
Plot3D1.VisibleXCoords := CBoxXCoords.Checked;
Plot3D1.VisibleYCoords := CBoxYCoords.Checked;
Plot3D1.VisibleZCoords := CBoxZCoords.Checked;
end;

(******************************************************************************)
procedure TForm1.ColSelXChange(Sender: TObject);
(******************************************************************************)

begin
Plot3D1.ColorXCoords := ColSelX.SelColor;
end;

(******************************************************************************)
procedure TForm1.ColSelYChange(Sender: TObject);
(******************************************************************************)

begin
Plot3D1.ColorYCoords := ColSelY.SelColor;
end;

(******************************************************************************)
procedure TForm1.ColSelZChange(Sender: TObject);
(******************************************************************************)

begin
Plot3D1.ColorZCoords := ColSelZ.SelColor;
end;

(******************************************************************************)
procedure TForm1.RGFrameModeClick(Sender: TObject);
(******************************************************************************)

begin
Plot3D1.SuppressPaint := true;
case RGFrameMode.ItemINdex of
  0 : begin
      Plot3D1.BoundBoxStyle := bbNone;
      end;
  1 : begin
      Plot3D1.ColorCubeFrame := $00e0e0e0;
      Plot3D1.ColorCubeHidLin := $00505050;
      Plot3D1.BoundBoxStyle := bbFrame;
      end;
  2 : begin
      Plot3D1.ColorCubeFrame := $00404040;
      Plot3D1.ColorCubeHidLin := $00B0B0B0;
      Plot3D1.BoundBoxStyle := bbFaces;
      end;
end;
Plot3D1.SuppressPaint := false;
end;


end.
